##PROJECT_GLOBAL_BEGIN
[Programs]
Count=1

[Misc Info]
Author=Damir
Company=Cybrotech Ltd
Version=1.2
EditTime=22577
CyProVersion=3.0.8

[Protection]
Level=0
Password=
##PROJECT_GLOBAL_END

##PROGRAM_BEGIN_1
#PROJECT_OPTIONS_BEGIN
[Program]
Name=New Program

[VCP]
I2CPriority=5
SendSource=1
SendAlloc=1
ProtectWithPasswd=0
Password=
ScanOverrunStopsProgram=1
OutputRetentive=0
AutoStart=1
Com1Mode=1
Com1Baudrate=3
Com1Data=0
Com2Mode=1
Com2Baudrate=3
Com2Data=0
EthAbusEnable=1
EthModbusEnable=0
WANUrl=
PushEvent=0
PushUrl=
ModbusDelay=20
ModbusDeviceAddress=1
ModbusPLCDataModel=2
ModbusAddress=0
ModbusRegisterCount=1
ModbusCoilsArrayVar=
ModbusRegistersArrayVar=
PLCCoilVars=
PLCRegisterVars=
ModbusCoilAddresses=
ModbusRegisterAddresses=

[Misc Info]
MonitorHistorySpeed=10

[Hardware]
CPUUnit=10
VarAreaTyp0.7.0=0
VarAreaTyp0.7.1=0
VarAreaTyp0.7.2=0
VarAreaTyp0.7.3=0
VarAreaTyp0.7.4=0
VarAreaTyp0.7.5=0
Card1=31
Type1=0
NAD1=-1
VarPrefix1=cr00_
Card2=31
Type2=0
NAD2=-1
VarPrefix2=cr01_
Card3=31
Type3=0
NAD3=-1
VarPrefix3=cr02_
Card4=31
Type4=0
NAD4=-1
VarPrefix4=cr03_
Card5=31
Type5=0
NAD5=-1
VarPrefix5=cr04_

[Net]
CurrentNAD=-1

[Monitor01]
VarCount=25
VarName1=cr00_general_error
VarBase1=1
VarValue1=0
VarColor1=0
VarIndex1=0
VarName2=cr00_id_hi_0
VarBase2=1
VarValue2=0
VarColor2=0
VarIndex2=1
VarName3=cr00_id_lo_0
VarBase3=1
VarValue3=0
VarColor3=0
VarIndex3=2
VarName4=cr00_id_len_0
VarBase4=1
VarValue4=44
VarColor4=0
VarIndex4=3
VarName5=cr00_green_led_0
VarBase5=1
VarValue5=0
VarColor5=0
VarIndex5=4
VarName6=cr00_red_led_0
VarBase6=1
VarValue6=0
VarColor6=0
VarIndex6=5
VarName7=cr00_id_hi_1
VarBase7=1
VarValue7=0
VarColor7=0
VarIndex7=6
VarName8=cr00_id_lo_1
VarBase8=1
VarValue8=0
VarColor8=0
VarIndex8=7
VarName9=cr00_id_len_1
VarBase9=1
VarValue9=0
VarColor9=0
VarIndex9=8
VarName10=id_allow[0]
VarBase10=1
VarValue10=565177607
VarColor10=0
VarIndex10=9
VarName11=id_allow[1]
VarBase11=1
VarValue11=0
VarColor11=0
VarIndex11=10
VarName12=id_allow[2]
VarBase12=1
VarValue12=0
VarColor12=0
VarIndex12=11
VarName13=id_allow[3]
VarBase13=1
VarValue13=0
VarColor13=0
VarIndex13=12
VarName14=id_allow[4]
VarBase14=1
VarValue14=0
VarColor14=0
VarIndex14=13
VarName15=id_allow[5]
VarBase15=1
VarValue15=1001063820
VarColor15=0
VarIndex15=14
VarName16=id_allow[6]
VarBase16=1
VarValue16=0
VarColor16=0
VarIndex16=15
VarName17=id_allow[7]
VarBase17=1
VarValue17=0
VarColor17=0
VarIndex17=16
VarName18=id_allow[8]
VarBase18=1
VarValue18=0
VarColor18=0
VarIndex18=17
VarName19=id_allow[9]
VarBase19=1
VarValue19=0
VarColor19=0
VarIndex19=18
VarName20=id_allow[10]
VarBase20=1
VarValue20=5
VarColor20=0
VarIndex20=19
VarName21=id_allow[11]
VarBase21=1
VarValue21=0
VarColor21=0
VarIndex21=20
VarName22=id_allow[12]
VarBase22=1
VarValue22=0
VarColor22=0
VarIndex22=21
VarName23=id_allow[13]
VarBase23=1
VarValue23=0
VarColor23=0
VarIndex23=22
VarName24=id_allow[14]
VarBase24=1
VarValue24=0
VarColor24=0
VarIndex24=23
VarName25=id_desk[0]
VarBase25=1
VarValue25=565177607
VarColor25=0
VarIndex25=24
#PROJECT_OPTIONS_END

#DMVARSLIST_BEGIN
#DMVARSLIST_END

#MASKS_BEGIN
#MASKS_END

#CODE_BEGIN
// AllocGroupList="User Variables", "I/O Variables", "Constants"
var retain
  id_allow: ARRAY[0..49] OF long; // Each room may have up to 5 allow acces codes, 50 variables for 10 rooms. {user}
var_end;

var constant
  OPENTIME = 50; // Preset time to allow guest to enter the room, after id is accepted. Base is 100ms.
  DENYTIME = 25; // Preset time to notify guest that access is denied. Base is 100ms.
var_end;

var
  id_req: ARRAY[0..9] OF long; // Request code from reader comes here, 10 variables for 10 rooms.
  id_log: ARRAY[0..39] OF long; // Log buffer for events. Each event has 4 fields (datetime, card_id, room, action), 40 variables for 10 events. {user}
  id_log_index: int; // Log buffer index, counting events (0 to 9), run-around.
  id_allow_cnt: ARRAY[0..9] OF int; // Allow timer, counting from preset to 0, base 100ms. Open lock and turn green LED on. 10 counters for 10 rooms.
  id_deny_cnt: ARRAY[0..9] OF int; // Deny timer, counting from preset to 0, base 100ms. Turn on red LED. 10 counters for 10 rooms.
  id_desk: ARRAY[0..9] OF long; // Reception reader code, used for CyBroAccess. {user}
var_end;

function main:void; language 'Structured Text';
  function input_mux:void; language 'Structured Text';
  begin
    
    // input multiplexer - copy id from reader to id_req[] and id_desk[] variables
    
    // module 0, reader 0, room 0
    
    if (cr00_id_hi_0 or cr00_id_lo_0)<>0 then
      id_req[0]:=16#10000*ulong(cr00_id_hi_0)+ulong(cr00_id_lo_0);
      id_desk[0]:=id_req[0];
      cr00_id_hi_0:=0;
      cr00_id_lo_0:=0;
    end_if;
    
    // module 0, reader 1, room 1
    
    if (cr00_id_hi_1 or cr00_id_lo_1)<>0 then
      id_req[1]:=16#10000*ulong(cr00_id_hi_1)+ulong(cr00_id_lo_1);
      id_desk[1]:=id_req[1];
      cr00_id_hi_1:=0;
      cr00_id_lo_1:=0;
    end_if;
    
    // module 1, reader 0, room 2
    
    if (cr01_id_hi_0 or cr01_id_lo_0)<>0 then
      id_req[2]:=16#10000*ulong(cr01_id_hi_0)+ulong(cr01_id_lo_0);
      id_desk[2]:=id_req[2];
      cr01_id_hi_0:=0;
      cr01_id_lo_0:=0;
    end_if;
    
    // module 1, reader 1, room 3
    
    if (cr01_id_hi_1 or cr01_id_lo_1)<>0 then
      id_req[3]:=16#10000*ulong(cr01_id_hi_1)+ulong(cr01_id_lo_1);
      id_desk[3]:=id_req[3];
      cr01_id_hi_1:=0;
      cr01_id_lo_1:=0;
    end_if;
    
    // module 2, reader 0, room 4
    
    if (cr02_id_hi_0 or cr02_id_lo_0)<>0 then
      id_req[4]:=16#10000*ulong(cr02_id_hi_0)+ulong(cr02_id_lo_0);
      id_desk[4]:=id_req[4];
      cr02_id_hi_0:=0;
      cr02_id_lo_0:=0;
    end_if;
    
    // module 2, reader 1, room 5
    
    if (cr02_id_hi_1 or cr02_id_lo_1)<>0 then
      id_req[5]:=16#10000*ulong(cr02_id_hi_1)+ulong(cr02_id_lo_1);
      id_desk[5]:=id_req[5];
      cr02_id_hi_1:=0;
      cr02_id_lo_1:=0;
    end_if;
    
    // module 3, reader 0, room 6
    
    if (cr03_id_hi_0 or cr03_id_lo_0)<>0 then
      id_req[6]:=16#10000*ulong(cr03_id_hi_0)+ulong(cr03_id_lo_0);
      id_desk[6]:=id_req[6];
      cr03_id_hi_0:=0;
      cr03_id_lo_0:=0;
    end_if;
    
    // module 3, reader 1, room 7
    
    if (cr03_id_hi_1 or cr03_id_lo_1)<>0 then
      id_req[7]:=16#10000*ulong(cr03_id_hi_1)+ulong(cr03_id_lo_1);
      id_desk[7]:=id_req[7];
      cr03_id_hi_1:=0;
      cr03_id_lo_1:=0;
    end_if;
    
    // module 4, reader 0, room 8
    
    if (cr04_id_hi_0 or cr04_id_lo_0)<>0 then
      id_req[8]:=16#10000*ulong(cr04_id_hi_0)+ulong(cr04_id_lo_0);
      id_desk[8]:=id_req[8];
      cr04_id_hi_0:=0;
      cr04_id_lo_0:=0;
    end_if;
    
    // module 4, reader 1, room 9
    
    if (cr04_id_hi_1 or cr04_id_lo_1)<>0 then
      id_req[9]:=16#10000*ulong(cr04_id_hi_1)+ulong(cr04_id_lo_1);
      id_desk[9]:=id_req[9];
      cr04_id_hi_1:=0;
      cr04_id_lo_1:=0;
    end_if;
    
  end;
  function output_mux:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i: int;
  var_end;

    function mux_allow(room:int; x:bit):void; language 'Structured Text';
    begin
      
      // translate room number to actual output
      
      case room of
        0: cr00_qx00:=x; cr00_green_led_0:=x; cr00_red_led_0:=0;
        1: cr00_qx01:=x; cr00_green_led_1:=x; cr00_red_led_1:=0;
      
        2: cr01_qx00:=x; cr01_green_led_0:=x; cr01_red_led_0:=0;
        3: cr01_qx01:=x; cr01_green_led_1:=x; cr01_red_led_1:=0;
      
        4: cr02_qx00:=x; cr02_green_led_0:=x; cr02_red_led_0:=0;
        5: cr02_qx01:=x; cr02_green_led_1:=x; cr02_red_led_1:=0;
      
        6: cr03_qx00:=x; cr03_green_led_0:=x; cr03_red_led_0:=0;
        7: cr03_qx01:=x; cr03_green_led_1:=x; cr03_red_led_1:=0;
      
        8: cr04_qx00:=x; cr04_green_led_0:=x; cr04_red_led_0:=0;
        9: cr04_qx01:=x; cr04_green_led_1:=x; cr04_red_led_1:=0;
      end_case;
      
    end;
    function mux_deny(room:int; x:bit):void; language 'Structured Text';
    begin
      
      // translate room number to actual output
      
      case room of
        0: cr00_qx00:=0; cr00_green_led_0:=0; cr00_red_led_0:=x;
        1: cr00_qx01:=0; cr00_green_led_1:=0; cr00_red_led_1:=x;
      
        2: cr01_qx00:=0; cr01_green_led_0:=0; cr01_red_led_0:=x;
        3: cr01_qx01:=0; cr01_green_led_1:=0; cr01_red_led_1:=x;
      
        4: cr02_qx00:=0; cr02_green_led_0:=0; cr02_red_led_0:=x;
        5: cr02_qx01:=0; cr02_green_led_1:=0; cr02_red_led_1:=x;
      
        6: cr03_qx00:=0; cr03_green_led_0:=0; cr03_red_led_0:=x;
        7: cr03_qx01:=0; cr03_green_led_1:=0; cr03_red_led_1:=x;
      
        8: cr04_qx00:=0; cr04_green_led_0:=0; cr04_red_led_0:=x;
        9: cr04_qx01:=0; cr04_green_led_1:=0; cr04_red_led_1:=x;
      end_case;
      
    end;
  begin
    
    // output multiplexer - handle id_allow and id_deny counters
    
    if fp(clock_100ms) then
      for i:=0 to 9 do
      // from first to last room
        if id_allow_cnt[i]>0 then
          id_allow_cnt[i]:=id_allow_cnt[i]-1;
          mux_allow(i,id_allow_cnt[i]>0);
        end_if;
        if id_deny_cnt[i]>0 then
          id_deny_cnt[i]:=id_deny_cnt[i]-1;
          mux_deny(i,id_deny_cnt[i]>0);
        end_if;
      end_for;
    end_if;
    
  end;
  function access_algo:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i: int;
    j: int;
    found: int;
  var_end;

    function add_event(id:long; room,action:int):void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var
      datetime: long;
    var_end;

    begin
      
      // add an event to event log
      
      datetime:=33554432*(rtc_year-1980)+2097152*rtc_month+65536*rtc_date+2048*rtc_hour+32*rtc_min+rtc_sec/2; // ms-dos date format
      
      id_log[4*id_log_index]:=datetime;
      id_log[4*id_log_index+1]:=id;
      id_log[4*id_log_index+2]:=room;
      id_log[4*id_log_index+3]:=action;
      
      id_log_index:=(id_log_index+1)%10;
      
    end;
  begin
    
    // access algo
    
    for i:=0 to 9 do
    // from first to last room
      if id_req[i]<>0 then
      // if event is detected
        found:=0;
        for j:=0 to 4 do
        // check if one of allow codes match
          if id_req[i]=id_allow[5*i+j] then
            found:=1;
          end_if;
        end_for;
        // according to result, allow or deny access
        if found=1 then
          id_allow_cnt[i]:=OPENTIME;
          id_deny_cnt[i]:=0;
        else
          id_deny_cnt[i]:=DENYTIME;
          id_allow_cnt[i]:=0;
        end_if;
        add_event(id_req[i],i,found); // add to event log
        id_req[i]:=0; // clear event request
      end_if;
    end_for;
    
  end;
begin
  /*****************************************************************************************
    Application:  AccessControl
    Minimal requirement: Cybro-3, CR-W2, 2xRFID reader
  
    Fully functional application for access control in hotel rooms.
  
    Each room needs RFid reader and electronic lock. Reception desk needs RFid reader
    and PC, running CyBroAccess. Its function is to write key codes to CyBro allowance
    array. Decision to allow access is made by controller.
  
    To run demo application:
  
      1. Connect RFID readers to CR-W2:
  
         room: CR-W2 reader 0
         desk: CR-W2 reader 1
  
      2. Autodetect CyBro, start program
  
      3. Download CyBroAccess, enter CyBro NAD in configuration (.ini) file, and start
  
    To use this program in a real-world application, adjust CyBroAccess.ini according to
    your required hardware configuration.
  
    This program supports up to 10 rooms per CyBro. To have more, you may modify program
    up to your needs: adjust array allocation, loop counts and input/output multiplexers.
  
    If your application need additional access points (hotel main entrance), you may add
    code which use existing allowance array to open the doors.
  *****************************************************************************************/
  
    input_mux(); // copy inputs to id_req and id_desk arrays
    access_algo(); // detect reader code, write event to id_log, set access timer
    output_mux(); // copy access timers to outputs
  
end;
#CODE_END

#DESCRIPTION_BEGIN
#DESCRIPTION_END

##PROGRAM_END_1

